/* grcurs.f -- translated by f2c (version 20090411).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include <stdio.h>
#include "pgplot.h"

/* Table of constant values */

static integer c__17 = 17;
static integer c__1 = 1;

/* *GRCURS -- read cursor position */
/* + */
integer grcurs_(integer *ident, integer *ix, integer *iy, integer *ixref, 
	integer *iyref, integer *mode, integer *posn, char *ch, ftnlen ch_len)
{
    /* Initialized data */

    static integer errcnt = 0;

    /* System generated locals */
    integer ret_val;
    char ch__1[46];

    /* Local variables */
    static char c__[1], chr[16];
    static integer lchr, nbuf;
    static real rbuf[6];
    static integer icurs;


/* GRPCKG: Read the cursor position and a character typed by the user. */
/* The position is returned in absolute device coordinates (pixels). */
/* GRCURS positions the cursor at the position specified, and */
/* allows the user to move the cursor using the joystick or */
/* arrow keys or whatever is available on the device. When he has */
/* positioned the cursor, the user types a single character on his */
/* keyboard; GRCURS then returns this character and the new cursor */
/* position. */

/* "Rubber band" feedback of cursor movement can be requested (although */
/* it may not be supported on some devices). If MODE=1, a line from */
/* the anchor point to the current cursor position is displayed as */
/* the cursor is moved. If MODE=2, a rectangle with vertical and */
/* horizontal sides and one vertex at the anchor point and the opposite */
/* vertex at the current cursor position is displayed as the cursor is */
/* moved. */

/* Returns: */

/* GRCURS (integer): 1 if the call was successful; 0 if the device */
/*      has no cursor or some other error occurs. */

/* Arguments: */

/* IDENT (integer, input):  GRPCKG plot identifier (from GROPEN). */
/* IX    (integer, in/out): the device x-coordinate of the cursor. */
/* IY    (integer, in/out): the device y-coordinate of the cursor. */
/* IXREF (integer, input):  x-coordinate of anchor point. */
/* IYREF (integer, input):  y-coordinate of anchor point. */
/* MODE  (integer, input):  type of rubber-band feedback. */
/* CH    (char,    output): the character typed by the user; if the device */
/*      has no cursor or if some other error occurs, the value CHAR(0) */
/*      [ASCII NUL character] is returned. */
/* -- */
/*  1-Aug-1984 - extensively revised [TJP]. */
/* 29-Jan-1985 - add ARGS and HP2648 devices (?) [KS/TJP]. */
/*  5-Aug-1986 - add GREXEC support [AFT]. */
/* 11-Jun-1987 - remove built-ins [TJP]. */
/* 15-Feb-1988 - remove test for batch jobs; leave this to the device */
/*               handler [TJP]. */
/* 13-Dec-1990 - remove code to abort after 10 cursor errors [TJP]. */
/*  7-Sep-1994 - add support for rubber-band modes [TJP]. */
/* 17-Jan-1995 - start picture if necessary [TJP]. */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */


/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */


/* ----------------------------------------------------------------------- */

/* Validate identifier, and select device. */

    grslct_(ident);
    grterm_();

/* Begin picture if necessary. */

    if (! grcm00_.grpltd[grcm00_.grcide - 1]) {
	grbpic_();
    }

/* Make sure cursor is on view surface. (It does not */
/* have to be in the viewport.) */

	if (*ix > grcm00_.grxmxa[grcm00_.grcide - 1]) *ix = grcm00_.grxmxa[grcm00_.grcide - 1];
	if (*ix < 0) *ix = 0;
	if (*iy > grcm00_.grymxa[grcm00_.grcide - 1]) *iy = grcm00_.grymxa[grcm00_.grcide - 1];
	if (*iy < 0) *iy = 0;

/* Does the device have a cursor? */

    *(unsigned char *)c__ = *(unsigned char *)&grcm01_.grgcap[(
	    grcm00_.grcide - 1) * 11 + 1];
    icurs = 0;
    if (*(unsigned char *)c__ == 'C' || *(unsigned char *)c__ == 'X') {
	icurs = 1;
    }

/* Device does have a cursor. */

    if (icurs > 0) {
/*         -- initial position of cursor */
	rbuf[0] = (real) (*ix);
	rbuf[1] = (real) (*iy);
/*         -- reference point for rubber band */
	rbuf[2] = (real) (*ixref);
	rbuf[3] = (real) (*iyref);
/*         -- rubber band mode */
	rbuf[4] = (real) (*mode);
/*         -- position cursor? */
	rbuf[5] = (real) (*posn);
	nbuf = 6;
	lchr = 0;
	grexec_(&grcm00_.grgtyp, &c__17, rbuf, &nbuf, chr, &lchr, (ftnlen)16)
		;
	*ix = rbuf[0];
	*iy = rbuf[1];
	ch[0] = chr[0];
	ret_val = 1;
/*         -- error if driver returns NUL */
	if (*(unsigned char *)chr == 0) {
	    ret_val = 0;
	}

/* Other devices are illegal. */

    } else {
	grexec_(&grcm00_.grgtyp, &c__1, rbuf, &nbuf, chr, &lchr, (ftnlen)16);
	lchr = 0;
	while ((chr[lchr] != ' ') && (lchr < 16)) lchr++;
	if (errcnt <= 10) {
		snprintf(ch__1, lchr + 29, "output device has no cursor: %s", chr);
	    grwarn_(ch__1, lchr + 29);
	}
	ch = '\0';
	ret_val = 0;
	++errcnt;
    }

    return ret_val;
} /* grcurs_ */

