/* grdtyp.f -- translated by f2c (version 20090411).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include <string.h>
#include "pgplot.h"

/* Table of constant values */

static integer c__0 = 0;
static integer c__1 = 1;

/* *GRDTYP -- decode graphics device type string */
/* + */
integer grdtyp_(char *text, ftnlen text_len)
{
    /* System generated locals */
    integer ret_val, i__1, i__2;

    /* Local variables */
    static integer i__, l;
    static char chr[32];
    static integer code, lchr, nbuf, ndev;
    static real rbuf[6];
    static integer match;

/* GRPCKG (internal routine): determine graphics device type code from */
/* type name. It compares the argument with the table of known device */
/* types in common. */

/* Argument: */

/* TEXT (input, character): device type name, eg 'PRINTRONIX'; the name */
/*       may be abbreviated to uniqueness. */

/* Returns: */

/* GRDTYP (integer): the device type code, in the range 1 to */
/*       GRTMAX, zero if the type name is not recognised, or -1 */
/*       if the type name is ambiguous. */
/* -- */
/* 27-Dec-1984 - rewrite so that is doesn't have to be modified for */
/*               new devices [TJP]. */
/*  5-Aug-1986 - add GREXEC support [AFT]. */
/* 10-Nov-1995 - ignore drivers that report no device type [TJP]. */
/* 30-Aug-1996 - check for an exact match; indicate if type is */
/*               ambiguous [TJP]. */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */


/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */


/* ----------------------------------------------------------------------- */

    ret_val = 0;
    l = grtrim_(text, text_len);
    if (l < 1) {
	return ret_val;
    }
    match = 0;
    code = 0;
    grexec_(&c__0, &c__0, rbuf, &nbuf, chr, &lchr, (ftnlen)32);
    ndev = (int)(rbuf[0] + 0.5);
    i__1 = ndev;
    for (i__ = 1; i__ <= i__1; ++i__) {
	grexec_(&i__, &c__1, rbuf, &nbuf, chr, &lchr, (ftnlen)32);
	if (lchr > 0) {
	    if (strncmp(text, chr, l) == 0) {
		i__2 = l;
		if (chr[l] == ' ') {
/*                 -- exact match */
		    ret_val = i__;
		    grcm00_.grgtyp = ret_val;
		    return ret_val;
		} else {
		    ++match;
		    code = i__;
		}
	    }
	}
/* L30: */
    }
    if (match == 0) {
/*        -- no match */
	ret_val = 0;
    } else if (match == 1) {
	ret_val = code;
	grcm00_.grgtyp = ret_val;
    } else {
	ret_val = -1;
    }

    return ret_val;
} /* grdtyp_ */

